/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2015
 * @version 1.3.3
 *
 * Date formatter utility library that allows formatting date/time variables or Date objects using PHP DateTime format.
 * @see http://php.net/manual/en/function.date.php
 *
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */var DateFormatter;!function(){"use strict";var t,e,r,n,a,i;a=864e5,i=3600,t=function(t,e){return"string"==typeof t&&"string"==typeof e&&t.toLowerCase()===e.toLowerCase()},e=function(t,r,n){var a=n||"0",i=t.toString();return i.length<r?e(a+i,r):i},r=function(t){var e,n;for(t=t||{},e=1;e<arguments.length;e++)if(n=arguments[e])for(var a in n)n.hasOwnProperty(a)&&("object"==typeof n[a]?r(t[a],n[a]):t[a]=n[a]);return t},n={dateSettings:{days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],daysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],meridiem:["AM","PM"],ordinal:function(t){var e=t%10,r={1:"st",2:"nd",3:"rd"};return 1!==Math.floor(t%100/10)&&r[e]?r[e]:"th"}},separators:/[ \-+\/\.T:@]/g,validParts:/[dDjlNSwzWFmMntLoYyaABgGhHisueTIOPZcrU]/g,intParts:/[djwNzmnyYhHgGis]/g,tzParts:/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,tzClip:/[^-+\dA-Z]/g},DateFormatter=function(t){var e=this,a=r(n,t);e.dateSettings=a.dateSettings,e.separators=a.separators,e.validParts=a.validParts,e.intParts=a.intParts,e.tzParts=a.tzParts,e.tzClip=a.tzClip},DateFormatter.prototype={constructor:DateFormatter,parseDate:function(e,r){var n,a,i,u,s,o,c,f,d,h,l=this,g=!1,m=!1,p=l.dateSettings,y={date:null,year:null,month:null,day:null,hour:0,min:0,sec:0};if(!e)return void 0;if(e instanceof Date)return e;if("number"==typeof e)return new Date(e);if("U"===r)return i=parseInt(e),i?new Date(1e3*i):e;if("string"!=typeof e)return"";if(n=r.match(l.validParts),!n||0===n.length)throw new Error("Invalid date format definition.");for(a=e.replace(l.separators,"\x00").split("\x00"),i=0;i<a.length;i++)switch(u=a[i],s=parseInt(u),n[i]){case"y":case"Y":d=u.length,2===d?y.year=parseInt((70>s?"20":"19")+u):4===d&&(y.year=s),g=!0;break;case"m":case"n":case"M":case"F":isNaN(u)?(o=p.monthsShort.indexOf(u),o>-1&&(y.month=o+1),o=p.months.indexOf(u),o>-1&&(y.month=o+1)):s>=1&&12>=s&&(y.month=s),g=!0;break;case"d":case"j":s>=1&&31>=s&&(y.day=s),g=!0;break;case"g":case"h":c=n.indexOf("a")>-1?n.indexOf("a"):n.indexOf("A")>-1?n.indexOf("A"):-1,h=a[c],c>-1?(f=t(h,p.meridiem[0])?0:t(h,p.meridiem[1])?12:-1,s>=1&&12>=s&&f>-1?y.hour=s+f-1:s>=0&&23>=s&&(y.hour=s)):s>=0&&23>=s&&(y.hour=s),m=!0;break;case"G":case"H":s>=0&&23>=s&&(y.hour=s),m=!0;break;case"i":s>=0&&59>=s&&(y.min=s),m=!0;break;case"s":s>=0&&59>=s&&(y.sec=s),m=!0}if(g===!0&&y.year&&y.month&&y.day)y.date=new Date(y.year,y.month-1,y.day,y.hour,y.min,y.sec,0);else{if(m!==!0)return!1;y.date=new Date(0,0,0,y.hour,y.min,y.sec,0)}return y.date},guessDate:function(t,e){if("string"!=typeof t)return t;var r,n,a,i,u=this,s=t.replace(u.separators,"\x00").split("\x00"),o=/^[djmn]/g,c=e.match(u.validParts),f=new Date,d=0;if(!o.test(c[0]))return t;for(n=0;n<s.length;n++){switch(d=2,a=s[n],i=parseInt(a.substr(0,2)),n){case 0:"m"===c[0]||"n"===c[0]?f.setMonth(i-1):f.setDate(i);break;case 1:"m"===c[0]||"n"===c[0]?f.setDate(i):f.setMonth(i-1);break;case 2:r=f.getFullYear(),a.length<4?(f.setFullYear(parseInt(r.toString().substr(0,4-a.length)+a)),d=a.length):(f.setFullYear=parseInt(a.substr(0,4)),d=4);break;case 3:f.setHours(i);break;case 4:f.setMinutes(i);break;case 5:f.setSeconds(i)}a.substr(d).length>0&&s.splice(n+1,0,a.substr(d))}return f},parseFormat:function(t,r){var n,u=this,s=u.dateSettings,o=/\\?(.?)/gi,c=function(t,e){return n[t]?n[t]():e};return n={d:function(){return e(n.j(),2)},D:function(){return s.daysShort[n.w()]},j:function(){return r.getDate()},l:function(){return s.days[n.w()]},N:function(){return n.w()||7},w:function(){return r.getDay()},z:function(){var t=new Date(n.Y(),n.n()-1,n.j()),e=new Date(n.Y(),0,1);return Math.round((t-e)/a)},W:function(){var t=new Date(n.Y(),n.n()-1,n.j()-n.N()+3),r=new Date(t.getFullYear(),0,4);return e(1+Math.round((t-r)/a/7),2)},F:function(){return s.months[r.getMonth()]},m:function(){return e(n.n(),2)},M:function(){return s.monthsShort[r.getMonth()]},n:function(){return r.getMonth()+1},t:function(){return new Date(n.Y(),n.n(),0).getDate()},L:function(){var t=n.Y();return t%4===0&&t%100!==0||t%400===0?1:0},o:function(){var t=n.n(),e=n.W(),r=n.Y();return r+(12===t&&9>e?1:1===t&&e>9?-1:0)},Y:function(){return r.getFullYear()},y:function(){return n.Y().toString().slice(-2)},a:function(){return n.A().toLowerCase()},A:function(){var t=n.G()<12?0:1;return s.meridiem[t]},B:function(){var t=r.getUTCHours()*i,n=60*r.getUTCMinutes(),a=r.getUTCSeconds();return e(Math.floor((t+n+a+i)/86.4)%1e3,3)},g:function(){return n.G()%12||12},G:function(){return r.getHours()},h:function(){return e(n.g(),2)},H:function(){return e(n.G(),2)},i:function(){return e(r.getMinutes(),2)},s:function(){return e(r.getSeconds(),2)},u:function(){return e(1e3*r.getMilliseconds(),6)},e:function(){var t=/\((.*)\)/.exec(String(r))[1];return t||"Coordinated Universal Time"},T:function(){var t=(String(r).match(u.tzParts)||[""]).pop().replace(u.tzClip,"");return t||"UTC"},I:function(){var t=new Date(n.Y(),0),e=Date.UTC(n.Y(),0),r=new Date(n.Y(),6),a=Date.UTC(n.Y(),6);return t-e!==r-a?1:0},O:function(){var t=r.getTimezoneOffset(),n=Math.abs(t);return(t>0?"-":"+")+e(100*Math.floor(n/60)+n%60,4)},P:function(){var t=n.O();return t.substr(0,3)+":"+t.substr(3,2)},Z:function(){return 60*-r.getTimezoneOffset()},c:function(){return"Y-m-d\\TH:i:sP".replace(o,c)},r:function(){return"D, d M Y H:i:s O".replace(o,c)},U:function(){return r.getTime()/1e3||0}},c(t,t)},formatDate:function(t,e){var r,n,a,i,u,s=this,o="";if("string"==typeof t&&(t=s.parseDate(t,e),t===!1))return!1;if(t instanceof Date){for(a=e.length,r=0;a>r;r++)u=e.charAt(r),"S"!==u&&(i=s.parseFormat(u,t),r!==a-1&&s.intParts.test(u)&&"S"===e.charAt(r+1)&&(n=parseInt(i),i+=s.dateSettings.ordinal(n)),o+=i);return o}return""}}}();